* D1.INC...INCLUDE FOR DISTRIB.RUL
* LAST CHANGE: 9-26-90
* ...USES BLOCKING, AS IN PRIMER
* ...ASSUMES MAIN RULE HAS :EXIT AND :ERR LABELS

$ANALYZE BLOCK ROW ERASE *
$ANALYZE BLOCK COL ERASE *
$ANALYZE SUB ROW D
$ANALYZE SUB COL H X=.1/*
$ANALYZE BL R S D?
$IF %NRBLKS = 0 THEN GOTO ERR
$ANALYZE BL C S H??
$IF %NCBLKS = 0 THEN GOTO ERR

$SET N=%NRBLKS
$LOOP
:NEXTBLK
$ANALYZE BL R REN SYN.%%N DEMAND.%%N
$CALC N = N - 1
$IF %%N > 0 THEN GOTO NEXTBLK
$ENDLOOP

$STACK 1
* STACK AREAS AND RENAME HARVEST ACTIVITY BLOCKS FOR
* THOSE THAT HAVE POSITIVE LEVELS
$LOOKUP BLOCK COL SYN.BB
$IF %VLOOK = 0 THEN SKIP 2
$QUEUE 1 BB
$ANALYZE BL C REN SYN.BB HRVST.BB
$LOOKUP BLOCK COL SYN.BR
$IF %VLOOK = 0 THEN SKIP 2
$QUEUE 1 BR
$ANALYZE BL C REN SYN.BR HRVST.BR
$LOOKUP BLOCK COL SYN.GA
$IF %VLOOK = 0 THEN SKIP 2
$QUEUE 1 GA
$ANALYZE BL C REN SYN.GA HRVST.GA
$LOOKUP BLOCK COL SYN.NR
$IF %VLOOK = 0 THEN SKIP 2
$QUEUE 1 NR
$ANALYZE BL C REN SYN.NR HRVST.NR
$LOOKUP BLOCK COL SYN.SM
$IF %VLOOK = 0 THEN SKIP 2
$QUEUE 1 SM
$ANALYZE BL C REN SYN.SM HRVST.SM
 Examine the following block picture.

$ANALYZE BL PIC
  The row blocks correspond to demands in each of the %NRBLKS
  time periods.
  The column blocks correspond to Harvest activities in the areas
  that fulfill the demands.  Their meanings are as follows.
$TEXT 1 MARGIN=3

* Use LOOP to go thru stack to interpret areas.
$LOOP
:NEXTAR
$POP 1 AR
 %%AR is
$ENTITY %%AR AR
$TEXT
$IF %NSTACK1 > 0 THEN GOTO NEXTAR
$ENDLOOP
$TEXT 1 MARGIN=1
 (Absence of an area in the column blocks means it does not get
 harvested.)
$GOTO EXIT
